import { Player, GameMode, EntityDamageCause, world } from "@minecraft/server";
export const bullet_list = {
    "l4d2:bullet_ak47": {
        damage: 33
    },
    "l4d2:bullet_shotgun_spas": {
        damage: 28
    },
    "l4d2:bullet_deagle": {
        damage: 80
    },
    "l4d2:bullet_pistol": {
        damage: 36
    },
};
world.afterEvents.projectileHitEntity.subscribe((xm) => {
    const entity_hit = xm.getEntityHit();
    const hitEntity = entity_hit.entity;
    const bullet = xm.projectile;
    const bullet_id = bullet.typeId;
    const bullet_def = bullet_list[bullet_id];
    if (entity_hit instanceof Player) {
        const hit_creative = hitEntity.matches({ gameMode: GameMode.creative }) || hitEntity.matches({ gameMode: GameMode.spectator });
        if (hit_creative == true)
            return;
    }
    if (!bullet_def)
        return;
    const bullet_damage = bullet_def.damage;
    let resistanceDefence = 0;
    if (hitEntity.typeId == "minecraft:player") {
        resistanceDefence = 1;
    }
    const damage = (Math.max(bullet_damage * (1 - resistanceDefence), 1));
    hitEntity.applyDamage(damage, {
        cause: EntityDamageCause.suicide,
        damagingProjectile: bullet,
    });
});
/*
const strength = 2.5;
const vertical = 0.5;

system.runInterval(() => {
    const players = world.getPlayers();
    for (let i = 0; i < players.length; i++) {
        const player = players[i];
        if (player.isOnGround) {
            player.hasJumped = false;
            continue;
        }
        if (player.hasJumped) continue;
        system.runTimeout(() => {
            if (player.isJumping) {
                player.hasJumped = true;
                const di = player.getViewDirection();
                player.applyKnockback(di.x, di.z, strength, di.y + vertical);
            }
        }, 3);
    }
}, 3);
*/
