import { Player, GameMode, EntityDamageCause, system, world } from "@minecraft/server";
export const melee_weapon_list = {
    //baseball_bat_attack
    "1": {
        damage: 100
    },
    "2": {
        damage: 100
    },
    //cricket_bat_attack
    "3": {
        damage: 100
    },
    //cricket_bat_attack
    "4": {
        damage: 100
    },
    //cricket_bat_attack
    "5": {
        damage: 100
    },
    //cricket_bat_attack
    "6": {
        damage: 100
    },
    //cricket_bat_attack
    "7": {
        damage: 100
    },
    //cricket_bat_attack
    "8": {
        damage: 100
    },
    //cricket_bat_attack
    "9": {
        damage: 100
    },
    //cricket_bat_attack
    "10": {
        damage: 100
    },
    //cricket_bat_attack
    "11": {
        damage: 100
    },
    //cricket_bat_attack
    "12": {
        damage: 100
    },
    //cricket_bat_attack
    "13": {
        damage: 100
    },
    //cricket_bat_attack
    "14": {
        damage: 100
    },
    //cricket_bat_attack
    "15": {
        damage: 100
    },
};
world.afterEvents.projectileHitEntity.subscribe((melee_attack) => {
    const source = melee_attack.source;
    if (!(source instanceof Player))
        return;
    const melee = melee_attack.projectile;
    if (melee.typeId != "l4d2:melee_attack")
        return;
    const entity_hit = melee_attack.getEntityHit();
    if (!entity_hit)
        return;
    const hit_entity = entity_hit.entity;
    if (entity_hit instanceof Player) {
        const hit_creative = hit_entity.matches({ gameMode: GameMode.creative }) || hit_entity.matches({ gameMode: GameMode.spectator });
        if (hit_creative == true)
            return;
    }
    const melee_id = JSON.stringify(melee.getComponent("minecraft:variant")?.value ?? 0);
    if (melee_id == "0")
        return;
    const melee_def = melee_weapon_list[melee_id];
    if (hit_entity.hasTag("l4d2_on_damage"))
        return;
    const bullet_damage = melee_def.damage;
    let resistanceDefence = 0;
    if (hit_entity.typeId == "minecraft:player") {
        resistanceDefence = 1;
    }
    const damage = (Math.max(bullet_damage * (1 - resistanceDefence), 1));
    hit_entity.applyDamage(damage, {
        cause: EntityDamageCause.suicide,
        damagingProjectile: melee,
    });
    hit_entity.addTag("l4d2_on_damage");
});
const overworld = world.getDimension("overworld");
const nether = world.getDimension("nether");
const the_end = world.getDimension("the_end");
const l4d2_on_damage_timer = new Map();
system.runInterval(() => {
    // Idk what you do up here
    const entities = [...overworld.getEntities(), ...nether.getEntities(), ...the_end.getEntities()];
    entities.forEach((entity) => {
        const l4d2_on_damage = l4d2_damage(entity);
        const timer = l4d2_on_damage_timer.get(entity.id);
        if (!l4d2_on_damage && timer)
            system.clearRun(timer);
        if (l4d2_on_damage && !timer) {
            l4d2_on_damage_timer.set(entity.id, system.runTimeout(() => {
                entity.removeTag('l4d2_on_damage');
                l4d2_on_damage_timer.delete(entity.id);
            }, 6));
        }
    });
});
function l4d2_damage(entity) {
    return entity.hasTag("l4d2_on_damage");
}
