import { system, world } from "@minecraft/server";
world.afterEvents.itemUse.subscribe((use) => {
    const player = use.source;
    if (player.getComponent("health").currentValue < player.getComponent("health").effectiveMax) {
        if (use.itemStack.typeId == "l4d2:painpills") {
            use_painpills(player);
        }
        if (use.itemStack.typeId == "l4d2:adrenaline") {
            use_adrenaline(player);
        }
    }
    else {
        return;
    }
});
function use_painpills(player) {
    let health = player.getComponent("health");
    let health_max = player.getComponent("health").effectiveMax;
    let health_currentvalue = ((health.currentValue / health_max) * 100);
    const temporary_hp_has = player.getProperty("l4d2:temporary_hp_has");
    if (temporary_hp_has != 1) {
        player.setProperty("l4d2:temporary_hp_has", 1);
        player.setProperty('l4d2:temporary_hp', health_currentvalue);
    }
    system.runTimeout(() => {
        health.setCurrentValue(health.currentValue + 50);
    }, 2);
}
function use_adrenaline(player) {
    let health = player.getComponent("health");
    let health_max = player.getComponent("health").effectiveMax;
    let health_currentvalue = ((health.currentValue / health_max) * 100);
    const temporary_hp_has = player.getProperty("l4d2:temporary_hp_has");
    if (temporary_hp_has != 1) {
        player.setProperty("l4d2:temporary_hp_has", 1);
        player.setProperty('l4d2:temporary_hp', health_currentvalue);
    }
    system.runTimeout(() => {
        health.setCurrentValue(health.currentValue + 25);
        player.addEffect("speed", 300, { amplifier: 1, showParticles: false });
    }, 2);
}
system.runInterval(() => {
    world.getPlayers().forEach((player) => {
        let health = player.getComponent("health");
        let health_currentvalue = player.getComponent("health").currentValue;
        const temporary_hp_has = player.getProperty("l4d2:temporary_hp_has");
        const temporary_hp = player.getProperty('l4d2:temporary_hp');
        if (temporary_hp_has && health.currentValue > temporary_hp) {
            health.setCurrentValue(health.currentValue - 1);
        }
        if (temporary_hp_has && health_currentvalue <= temporary_hp) {
            player.setProperty("l4d2:temporary_hp_has", 0);
            player.setProperty("l4d2:temporary_hp", 100);
            return;
        }
    });
}, 60);
